/*	Title: 	gprint.c
 *  Subtitle:  definition of function gprint()
 *  Classification:  public-domain
 *  
 *  Author:  R.E. Sawyer
 *  Date: 14 April 84
 *  
 *  Description:  gprint() prints a selected 720x348 graphics page
 *	              
 *	Hardware requirements:  Hercules Graphics Card/ IBM mono monitor
 *							Epson MX80/Graftrax printer
 *  
 *  Language:  C (DeSmet V2.x)
 *	Usage:  int page;
 *			gprint(page);
 *	Performance: print-time is just over 3 minutes
 */


main(argc, argv)
int argc;
char *argv[];
	{
	if (argc != 2)
		{
		printf("\nUsage:  gprint page#");
		exit();
		}
	gprint(atoi(argv[1]));
	}

 
gprint(page)
int page;
	{
	int a, b, c, fnbr, seg;                     
	page ? (seg = 0xb800) : (seg = 0xb000);

	if ((fnbr = fopen("prn:", "w")) == 0)
		{
		printf("\nCan't open prn:\n");
		exit();
		}
	
	fputc('\033', fnbr);       /* set printer linefeed spacing */
	fputc('\101', fnbr);
	fputc('\010', fnbr);

	for (c=0; c<90; ++c)       /* for 90 successive passes of the */
		{                              /* 8-bit wide printer head */
		fputc('\012', fnbr);   /* linefeed */
		fputc('\033', fnbr);   /* set graphics mode for next pass */
		fputc('\113', fnbr);            
		fputc('\134', fnbr);
		fputc('\001', fnbr);
		
		for (b=0; b<=7740; b+=90) /* for successive 4-byte blocks */
			{                             /* (87 blocks per pass) */
			a = c - b;               /* define appropriate offset */ 
								  	
			fputc(_peek(a+32316, seg), fnbr);  /* print the block */
			fputc(_peek(a+24124, seg), fnbr);
			fputc(_peek(a+15932, seg), fnbr);  /* [total pixels = */
			fputc(_peek(a+ 7740, seg), fnbr);  /*  720x348 =      */
			}                                  /*  90x(8x(87x4))] */ 
		}
	fputc('\033', fnbr);         /* restore printer control codes */ 
	fputc('\100', fnbr);
	fclose(fnbr);                              
	}
	
